=== debian/changelog ===
hedgewars (0.9.14.1-1) unstable; urgency=low

  * New upstream version.
   + New audio tracks
   + New forts: EvilChicken, Tank
   + New game modes: AI Survival Mode, Per Hedgehog Ammo,
     Reset Health, Reset Weapons, Unlimited Attacks
   + New grave: ring
   + Over 30 new hats
   + New themes: Art, Brick, Jungle, Stage
   + New maps: ShoppaKing, Sticks, TrophyRace (Mission)
   + New utilities: Portal Gun, Resurrector
   + New weapons: Flamethrower, Hammer, Old Limburger,
     Piano Strike, Sticky Mines
   + Weapons' projectiles will how be launched from their
     barrels instead of the hog's center
   + Flying Saucers may be used for moving below the water surface
   + New default game schemes: Clean Slate, Fort Mode, Timeless,
     Thinking with Portals, King Mode
   + New default weapon set: Clean Slate, Thinking with Portals
   + Bomb clusters/Melon parts inherit some of the original bomb's speed
   + Extended game statistics
   + Improved health bar updating
   + Hogs that blow themselves up will use triggers in they team color
   + Settings allow better control over the level of details/effects
   + Improved Lua support
   + On empty ammo switch to no weapon rather than the first available
     one (to avoid shooting by accident)
   + Display of hints in the frontend
   + Some improvements of existing Themes of Maps
   + Land destruction effects added
   + Improved fire effects
   + Improved Melon explosion effects
   + Online game lobby now features game filters
   + Other Frontend enhancements
   + Additional sounds
   + Show special game rules in Esc screen
   + Updated translation
   + Speed optimizations
   + Hedgewars will now use a sub directory of "My Documents"
     like other games instead of "%userprofile%/.hedgewars" under Windows
   + Added support for graphics cards/drivers that have a 512x512
     pixel textures limit
   + Team colors are more distinguishable from each other now
   * Fixed bug that allowed charging a weapon while on rope,
     leading to frozen timer
   * Various bug fixes
  * Switched to 3.0 source format.
  * Switched to cdbs build system.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 14 Nov 2010 22:45:48 +0300

hedgewars (0.9.13-1) unstable; urgency=low

  * New upstream version, closes: #576370
    * many bug fixes
    * speed optimisations
    * many new hats, hats visible while using rope and blowtorch
    * Exploding barrels
    * AI uses new weapons, aware of fire, can fight in artillery mode
    * New options in ammo editing - crate probability, delays
    * option of semi-opaque hog name tags to avoid fail when
      land is hidden by name
    * new British voicepack
    * notification sound when people join your room
    * translation updates
    * contextual help when using weapons menu
    * 3d effect for waves
    * fade effect when starting/stopping game
    * new game modes - place hedgehog, king mode, randomise starts,
      allies share ammo, disable girders
    * shift + direction to turn without moving
    * view ammo menu when not your turn
    * new font for CJK text and better CJK detection
    * dud mines
    * hat reservation for donators (hats should be released to public
      in 6 months or so)
    * team flags
    * visual effects: dust on fall impact, smoke, shotgun shells,
      blink team name on start of turn, hogs pulling weapons out,
      falling flakes kicked by explosion and more
    * hogs react to throwing grenades / dynamite and when near them
    * graphic of crate contents when picking up weapon/utility
    * walk sound for hedgehogs
    * UFO changed to homing bee
    * splashes/droplets when things fall in the water
    * 45 degree bounce when throwing grenades
    * new bounce sounds
    * information on game rules when starting game
    * knockball map (scripted map)
    * Birdy weapon and poisoning effect
    * maze generator for new random maps
    * new crazy map template
    * new Olympics, Desert themes, visual updates to many other themes
    * Background texture for land for a 3d effect on explosions
    * frontend able to delete teams
    * ignore/friends lists in frontend
    * alt weapon preview on rope, parachute
    * updated options in frontend: independent toggles for
      frontend/game sound/music, select locale
    * More
    * lua scripting
      Lua scripting allows the easy creation of missions and special maps.
      Examples of this can be seen in the Knockball and Basketball maps,
      that are now scripted

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 05 Apr 2010 10:39:04 +0400

hedgewars (0.9.12-2) unstable; urgency=low

  * fixes 'FTBFS: Error: Illegal parameter: -Nu', closes: #573694,
    thanks for Lucas Nussbaum <lucas@lucas-nussbaum.net>.

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 15 Mar 2010 11:03:16 +0300

hedgewars (0.9.12-1) unstable; urgency=low

  * New upstream version.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 18 Oct 2009 22:39:07 +0400

hedgewars (0.9.11-5) unstable; urgency=low

  * Icon for .desktop file has been installed, too, closes: #540235,
    thanks for Andrew SB <a.starr.b@gmail.com>.

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 06 Aug 2009 22:38:40 +0400

hedgewars (0.9.11-4) unstable; urgency=low

  * Fixed FTBFS: added absent build-depends.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 05 Aug 2009 12:02:26 +0400

hedgewars (0.9.11-3) unstable; urgency=low

  * Turned on network/server features (server was patched for buildling by
    new haskell-compiler).

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 05 Aug 2009 10:44:23 +0400

hedgewars (0.9.11-2) unstable; urgency=low

  * Added Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
    to uploaders list.
  * debian/copyright has been updated (added section about fonts).

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 07 Jul 2009 15:38:33 +0400

hedgewars (0.9.11-1) unstable; urgency=low

  * New upstream version, closes: #526975, #532851.

