=== debian/rules ===
#!/usr/bin/make -f

DEB_CMAKE_INSTALL_PREFIX := /usr/lib/hedgewars
DEB_CMAKE_EXTRA_FLAGS      := -DWITH_SERVER=1 \
	-DDATA_INSTALL_DIR=/usr/share/games

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk
